{ This program demo borrows heavily from Davide Moretti's Rastest
  I have just added some kewl features to this awesome program written
  by Dave. All credits to Dave!
  You may download Dave's original program from www.programmersheaven.com
  (d_ras.zip) Thanks for trying this out. Please mail your suggestions to
  abhishekdutta@mail.com
 }
unit TestForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Ras,
  StdCtrls,  ExtCtrls, FileCtrl, Registry, Menus, IniFiles;

 function shellExecute(HWND:  integer;
    lpOperation: pchar;	// pointer to string that specifies operation to perform
    lpFile: pchar;	// pointer to filename string
    lpParameters: pchar;// pointer to string that specifies executable-file parameters
    lpDirectory: pchar;	// pointer to string that specifies default directory
    nShowCmd: integer) : integer; stdcall;	// whether file is shown when opened
    external 'shell32.dll' name 'ShellExecuteA';


type
   TfrmTest = class(TForm)
    btnGetEntries: TButton;
    btnEditEntry: TButton;
    btnHangup: TButton;
    btnDialEntry: TButton;
    btnSetParams: TButton;
    btnGetParams: TButton;
    txtUserName: TEdit;
    txtPassword: TEdit;
    lblStatus: TLabel;
    lblUserName: TLabel;
    lblPassword: TLabel;
    lstentries: TComboBox;
    Label1: TLabel;
    chkads: TCheckBox;
    chkcookies: TCheckBox;
    Timer1: TTimer;
    FileListBox1: TFileListBox;
    Memo1: TMemo;
    btnactiveconn: TButton;
    Timer2: TTimer;
    Memo2: TMemo;
    Label2: TLabel;
    pop: TPopupMenu;
    mnuentry: TMenuItem;
    mnumodem: TMenuItem;
    mnutele: TMenuItem;
    N1: TMenuItem;
    mnumail: TMenuItem;
    mnuabout: TMenuItem;
    procedure btnGetEntriesClick(Sender: TObject);
    procedure btnEditEntryClick(Sender: TObject);
    procedure btnDialEntryClick(Sender: TObject);
    procedure btnHangupClick(Sender: TObject);
    procedure btnGetParamsClick(Sender: TObject);
    procedure txtUserNameChange(Sender: TObject);
    procedure btnSetParamsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure chkcookiesClick(Sender: TObject);
    procedure chkadsClick(Sender: TObject);
    procedure blockads;
    procedure clearads;
    procedure exitsettings;
    procedure initsettings;
    procedure btnactiveconnClick(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure AppException(Sender: TObject; E: Exception);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mnuentryClick(Sender: TObject);
    procedure mnuaboutClick(Sender: TObject);
    procedure mnumodemClick(Sender: TObject);
    procedure mnumailClick(Sender: TObject);
    procedure mnuteleClick(Sender: TObject);

  private
    { Private declarations }
    dialparams: TRasDialParams;
    hras: THRasConn;
    sysdir: array [0..144] of char;
    site: string;

  public
    { Public declarations }
  end;

var
  frmTest: TfrmTest;

implementation

{$R *.DFM}

function StatusString(state: TRasConnState; error: Longint): String;
  var
    c: Array[0..100] of Char;
    s: String;
  begin
  if error <> 0 then
    begin
    RasGetErrorString(error, c, 100);
    Result := c;
    frmtest.btnhangup.click;
    end
  else
    begin
    s := '';
    case State of
      RASCS_OpenPort:
        s := 'Opening port';
      RASCS_PortOpened:
        s := 'Port opened';
      RASCS_ConnectDevice:
        s := 'Connecting device';
      RASCS_DeviceConnected:
        s := 'Device connected';
      RASCS_AllDevicesConnected:
        s := 'All devices connected';
      RASCS_Authenticate:
        s := 'Authenticating';
      RASCS_AuthNotify:
        s := 'Authentication: notify';
      RASCS_AuthRetry:
        s := 'Authentication: retry';
      RASCS_AuthCallback:
        s := 'Authentication: callback';
      RASCS_AuthChangePassword:
        s := 'Authentication: change password';
      RASCS_AuthProject:
        s := 'Authentication: projecting';
      RASCS_AuthLinkSpeed:
        s := 'Authentication: link speed';
      RASCS_AuthAck:
        s := 'Authentication acknowledged';
      RASCS_ReAuthenticate:
        s := ' Reauthenticating';
      RASCS_Authenticated:
        s := 'Authenticated. Logging on network';
      RASCS_PrepareForCallback:
        s := 'Preparing for callback';
      RASCS_WaitForModemReset:
        s := 'Waiting for modem reset';
      RASCS_WaitForCallback:
        s := 'Waiting for callback';
      RASCS_Projected:
        s := 'Projected';
      RASCS_StartAuthentication:
        s := 'Authenticating';
      RASCS_CallbackComplete:
        s := 'Callback complete';
      RASCS_LogonNetwork:
        s := 'Logging on network';
      RASCS_Interactive:
        s := 'Interactive';
      RASCS_RetryAuthentication:
        s := 'Retry Authentication';
      RASCS_CallbackSetByCaller:
        s := 'Callback set by caller';
      RASCS_PasswordExpired:
        s := 'Password expired';
      RASCS_Connected:
        s := 'Connected';
      RASCS_Disconnected:
        s := 'Disconnected';
      end;
    Result := s;
    end;
  end;

// Callback RAS function
procedure RasCallback(msg: Integer; state: TRasConnState;
    error: Longint); stdcall
 begin
 frmtest.lblstatus.caption := statusstring(state, error);
 if strcomp(pchar(statusstring(state, error)), 'Connected')= 0 then
   begin
   ShellExecute (frmtest.handle, 'Open', pchar(frmtest.site),nil, nil, SW_SHOWMAXIMIZED);
   frmtest.timer2.enabled:=true;
   end;
 end;

procedure TfrmTest.btnGetEntriesClick(Sender: TObject);
  var
    bufsize: Longint;
    numEntries: Longint;
    entries: Array[1..12] of TRasEntryName;
    x: Integer;
  begin
  btnEditEntry.Enabled := False;
  txtUserName.Text := '';
  txtPassword.Text := '';
  entries[1].dwSize := SizeOf(TRasEntryName);
  bufsize := SizeOf(TRasEntryName) * 12;
  if RasEnumEntries(nil, nil, @entries[1], bufsize, numEntries) = 0 then
    begin
    if numEntries > 0 then
      begin
      for x := 1 to numEntries do
        lstEntries.Items.Add(entries[x].szEntryName);
        lstEntries.ItemIndex := 0;
        btnEditEntry.Enabled := True;
      end;
    end
  else
    MessageDlg('Error : Cannot retrieve entry names', mtCustom,[mbOK] ,0);
  end;


procedure TfrmTest.btnEditEntryClick(Sender: TObject);
  begin
  pop.popup(frmtest.left + 158,frmtest.top + 133);
  end;

procedure TfrmTest.btnDialEntryClick(Sender: TObject);
  var
    r: integer;
    c: Array[0..100] of Char;
  begin
  lblstatus.caption :='';
  if txtpassword.text = '' then
  begin
   messagedlg('Please enter your password', mtCustom,[mbOK] ,0);
   exit;
  end;
  FillChar(dialparams, SizeOf(TRasDialParams), 0);
  with dialparams do
    begin
    dwSize := Sizeof(TRasDialParams);
    StrPCopy(szEntryName, lstEntries.Items[lstEntries.ItemIndex]);
    StrPCopy(szUserName, txtUserName.Text);
    strpcopy(szpassword, txtpassword.text);
    // You can override phone number here...

    end;
    hRas := 0;
    r := RasDial(nil,   // This field is ignored in Windows95
        nil,  // Phonebook: use default (not used on Win95)
        dialparams,
        0, // use callback function of type RASDIALFUNC
        @RasCallback,   // callback function
        hRas);
        btnSetParams.Click;
  if r <> 0 then
    begin
    RasGetErrorString(r, c, 100);
    lblstatus.caption:= c;
    end;
  btnhangup.enabled:=true;
  btndialentry.enabled:=false;
  lstentries.enabled:=false;
  txtusername.enabled:=false;
  txtpassword.enabled:=false;
  end;

procedure TfrmTest.btnHangupClick(Sender: TObject);
begin
if  hRas = 0 then
 exit;
  if RasHangUp(hRas) <> 0 then
    begin
     MessageDlg('Error : Cannot hangup connection.', mtCustom,[mbOK] ,0);
    end;
  btnhangup.enabled:=false;
  lstentries.enabled:=true;
  txtusername.enabled:=true;
  txtpassword.enabled:=true;
  txtpassword.text:='';
  btndialentry.enabled:=true;
  end;

procedure TfrmTest.btnGetParamsClick(Sender: TObject);
  var
    fp: LongBool;
    r: Longint;
    c: Array[0..100] of Char;
  begin
  if lstentries.itemindex=-1 then
   exit;

  FillChar(dialparams, SizeOf(TRasDialParams), 0);
  with dialparams do
    begin
    dwSize := Sizeof(TRasDialParams);
    StrPCopy(szEntryName, lstEntries.Items[lstEntries.ItemIndex]);
    end;
  r := RasGetEntryDialParams(nil, dialparams, fp);
  if r = 0 then
    with dialparams do
      begin
      txtUserName.Text := szUserName;
      txtpassword.text := '';
      if fp then
        txtPassword.Text := szPassword;
      end
  else
    begin
    RasGetErrorString(r, c, 100);
    MessageDlg(('Error : ' + c), mtCustom,[mbOK] ,0);
    end;
  end;

procedure TfrmTest.txtUserNameChange(Sender: TObject);
  begin
  if lstEntries.ItemIndex = -1 then
    Exit;
    btnDialEntry.Enabled := (txtUserName.Text <> '');
  end;

procedure TfrmTest.btnSetParamsClick(Sender: TObject);
  begin
    with dialparams do
      begin
      dwSize := Sizeof(TRasDialParams);
      StrPCopy(szEntryName, lstEntries.Items[lstEntries.ItemIndex]);
      StrPCopy(szUserName, txtUserName.Text);
      StrPCopy(szpassword, '');
      RasSetEntryDialParams(nil, dialparams, True);
    end;
  end;

procedure TfrmTest.FormCreate(Sender: TObject);
begin
ShowWindow(Application.Handle, SW_HIDE);
Application.OnException := AppException;
hras:=0;
FillChar(sysdir, SizeOf(sysdir), #0);
GetWindowsDirectory(sysdir, 144);
initsettings;
btngetentries.click;
btngetparams.click;
btnactiveconn.click;
if directoryexists(sysdir + '\cookies') then
 filelistbox1.directory := sysdir +'\cookies';
end;
procedure TfrmTest.Timer1Timer(Sender: TObject);
begin
filelistbox1.itemindex:=filelistbox1.topindex;
deletefile(filelistbox1.filename);
filelistbox1.update;
end;

procedure TfrmTest.chkcookiesClick(Sender: TObject);
begin
timer1.enabled:=chkcookies.checked
end;

procedure TfrmTest.chkadsClick(Sender: TObject);
begin
 if chkads.checked = true then
   begin
    blockads;
   end
 else
    clearads;
 end;

procedure TfrmTest.blockads;
begin
  if fileexists(sysdir + '\hosts') then
   begin
    setfileattributes(pchar(sysdir + '\hosts'), FILE_ATTRIBUTE_NORMAL);
    memo2.lines.loadfromfile (sysdir +'\hosts');
   end;
  memo1.lines.savetofile(sysdir + '\hosts');
end;

procedure TfrmTest.clearads;
begin
 memo2.lines.savetofile(sysdir +'\hosts');
end;
procedure TfrmTest.btnactiveconnClick(Sender: TObject);
  var
    bufsize: Longint;
    numEntries: Longint;
    x: Integer;
    entries: Array[1..100] of TRasConn;
    stat: TRasConnStatus;
  begin
  entries[1].dwSize := SizeOf(TRasConn);
  bufsize := SizeOf(TRasConn) * 100;
  FillChar(stat, Sizeof(TRasConnStatus), 0);
  stat.dwSize := Sizeof(TRasConnStatus);
  if RasEnumConnections(@entries[1], bufsize, numEntries) = 0 then
    begin
    if numEntries > 0 then
      begin
        for x := 1 to numEntries do
          with frmtest, entries[x] do
          begin
          hras := hrasconn;
          RasGetConnectStatus(hras, stat);
          lblstatus.caption := StatusString(stat.rasconnstate, stat.dwError) ;
          btndialentry.enabled:=false;
          btnhangup.enabled:=true;
          end;
      end
      else
       begin
        timer2.enabled:=false;
        lblstatus.caption :='Not connected';
        btndialentry.enabled:=true;
        btnhangup.enabled:=false;
       end;
    end
  else
  Messagedlg ('Error : Cannot retrieve connection details ', mtCustom,[mbOK] ,0);
end;

procedure TfrmTest.Timer2Timer(Sender: TObject);
begin
btnactiveconn.click;
end;


procedure TfrmTest.AppException(Sender: TObject; E: Exception);
begin
  Application.ShowException(E);
end;

procedure TfrmTest.FormClose(Sender: TObject; var Action: TCloseAction);
begin
clearads;
exitsettings;
end;

procedure TfrmTest.initsettings;
var
curdir: array [0..144] of char;
reg : TRegIniFile;
ConIni: TIniFile;
begin
FillChar(curdir, SizeOf(curdir), #0);
getcurrentdirectory(144, curdir);
reg :=TRegIniFile.Create('');
reg.RootKey := HKEY_CURRENT_USER;
reg.WriteString('Software\Microsoft\Internet Explorer\Main','Window Title','Connector 1.3');
reg.writestring('Software\Connector','Version','1.3.0');
reg.writestring('Software\Connector','App_Path',curdir);
reg.free;
ConIni := TIniFile.Create('DXCONMGR.INI');
chkads.checked:=ConIni.ReadBool('Options', 'ADS', chkads.checked);
chkcookies.checked:=ConIni.ReadBool('Options', 'CKS', chkcookies.checked);
if chkads.checked=true then
blockads;

timer1.enabled:=chkcookies.checked;
site:=ConIni.ReadString('Options','URL','www.yahoo.com');
ConIni.Free;
end;

procedure TfrmTest.exitsettings;
var
reg : TRegIniFile;
ConIni: TIniFile;
begin
reg :=TRegIniFile.Create('');
reg.RootKey := HKEY_CURRENT_USER;
reg.WriteString('Software\Microsoft\Internet Explorer\Main','Window Title','Microsoft Internet Explorer');
reg.free;
ConIni := TIniFile.Create('DXCONMGR.INI');
ConIni.WriteBool('Options', 'ADS', chkads.checked);
ConIni.WriteBool('Options', 'CKS', chkcookies.checked);
ConIni.Free;
end;


procedure TfrmTest.mnuentryClick(Sender: TObject);
begin
if lstEntries.ItemIndex=-1 then
 exit;
if RasEditPhonebookEntry(Handle, nil,
   PChar(lstEntries.Items[lstEntries.ItemIndex])) <> 0 then
   MessageDlg('Error : Cannot edit entry property', mtCustom,[mbOK] ,0);
end;

procedure TfrmTest.mnuaboutClick(Sender: TObject);
begin
messagedlg('Created by Abhishek Dutta', mtcustom,[mbok],0)
end;

procedure TfrmTest.mnumodemClick(Sender: TObject);
begin
   ShellExecute (frmtest.handle,'open', 'RunDLL32' , 'shell32.dll,Control_RunDLL MODEM.CPL,Modems', nil, SW_SHOWDEFAULT);
end;

procedure TfrmTest.mnumailClick(Sender: TObject);
begin
  ShellExecute (frmtest.handle, 'open', 'mailto:abhishekdutta@mail.com', nil,nil, SW_SHOW);
end;

procedure TfrmTest.mnuteleClick(Sender: TObject);
begin
   ShellExecute (frmtest.handle,'open', 'RunDLL32' , 'shell32.dll,Control_RunDLL TELEPHON.CPL', nil, SW_SHOWDEFAULT);
end;

end.
